  case VGA_CS_TVGA8900:
  case VGA_CS_TVGA9000:
    set_clockbits(index);

    /* Select "new mode regs" for CS2 and TVGA9000 CS3 */
    vga_outseq(0x0B, 0);
    vga_inseq(0x0B);

    // According to Michael Karcher, the clock division bits are as follows:
    // Bit0  Bit1   Divisor
    //  0     0        1
    //  0     1        2
    //  1     0        4
    //  1     1       1.5

    /* Set clock dividers to no division */
    vga_outseq_bit(0x0D, 1, 0);
    vga_outseq_bit(0x0D, 2, 0);

    vga_outseq_bit(0x0D, 0, index & 4);
    if(vga_chipset == VGA_CS_TVGA9000)
      vga_outseq_bit(0x0D, 6, index & 8);
    else if(vga_chipset == VGA_CS_TVGA8900 && vga_num_clocks > 7) {
      /* Switch to "old mode" for CS3 */
      vga_outseq(0x0B, 0);
      vga_outseq_bit(0x0E, 4, index & 8);
    }
    break;

  case VGA_CS_PVGA1:
  case VGA_CS_WDC90C0X:
  case VGA_CS_WDC90C1X:
  case VGA_CS_WDC90C2X:
  case VGA_CS_WDC90C3X: {
    int MClkIndex=(vga_num_clocks > 8)?(vga_num_clocks-1):8;

    if(index == MClkIndex && vga_chipset != VGA_CS_PVGA1) {
      /* On all of the chipsets after PVGA1, you can feed MCLK as VCLK. */
      vga_outcrtc_bit(0x2E, 4, 1);
    } else if(vga_chipset != VGA_CS_PVGA1) {
      /* Disable feeding MCLK to VCLK */
      vga_outcrtc_bit(0x2E, 4, 0);
    }

    /* Set bits 0 & 1 */
    set_clockbits(index);

    /* Set bit 2 */
    if(vga_chipset == VGA_CS_WDC90C0X)
      vga_outgra_bit(0x0C, 1, (index & 4) ^
                  ((vga_options & VGA_OPT_SWAP_HIBIT)?4:0));
    else if(vga_chipset != VGA_CS_PVGA1)
      vga_outgra_bit(0x0C, 1, (index & 4) ^
                  ((vga_options & VGA_OPT_SWAP_HIBIT)?0:4));

    /* Set bit 3 */
    if(vga_chipset == VGA_CS_WDC90C3X)
      vga_outseq_bit(0x12, 2, (index & 8) ^ 8);

    break;
  }
